// XMLDoc.cpp : Implementierung der Klasse CXMLDoc
//

#include "stdafx.h"
#include "XML.h"

#include "XMLDoc.h"
#include "XMLException.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CXMLDoc

IMPLEMENT_DYNCREATE(CXMLDoc, CDocument)

BEGIN_MESSAGE_MAP(CXMLDoc, CDocument)
END_MESSAGE_MAP()


// CXMLDoc Erstellung/Zerstrung

CXMLDoc::CXMLDoc()
{
	// TODO: Hier Code fr One-Time-Konstruktion einfgen
	//Erzeugen der Punktliste:
	this->listPoints = new CList<CPoint, CPoint> ();
}

CXMLDoc::~CXMLDoc()
{
	//Lschen der Punktliste:
	this->listPoints->RemoveAll();
	delete this->listPoints;
}

BOOL CXMLDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)

	//Die Liste der Punkte nur leeren (erforderlich z.B. beim Laden).
	this->listPoints->RemoveAll();

	return TRUE;
}




// CXMLDoc Serialisierung

void CXMLDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here

		//Den MFC-Speicherungsmechanismus umgehen und XML erzeugen:
		MSXML2::IXMLDOMDocumentPtr domDocument; //pointer to the xml document
		::CoInitialize(NULL);

		HRESULT hr = domDocument.CreateInstance (CLSID_DOMDocument);
		//Gem Doku mte das auch so gehen !
		//HRESULT hr = domDocument.CreateInstance (__uuidof(MSXML2::DOMDocument30));
		if (FAILED (hr) )
		{
			//_com_error ist eine Kapselklasse um COM-Fehler.
			_com_error er (hr);
			//Saubere Exception mit Fehlermeldung auslsen:
			CString sError = "Fehler beim Initialisieren von MSXML: ";
			sError += er.ErrorMessage ();
			throw new CXMLException ( sError);
		}
		//Den Knoten "points" erzeugen:
		MSXML2::IXMLDOMElementPtr domElementPoints = domDocument->createElement ("points");
		domDocument->appendChild (domElementPoints);

		//In einer Schleife die Punkte erzeugen:
		for (int intIndex = 0; intIndex < this->GetPointNumber(); intIndex++)
		{
			CPoint pointAktuell = this->GetPointAt (intIndex);

			MSXML2::IXMLDOMElementPtr domElementPoint = domDocument->createElement ("point");
			MSXML2::IXMLDOMAttributePtr domAttributeX = domDocument->createAttribute ("x");
			domAttributeX->Putvalue (pointAktuell.x); 
			MSXML2::IXMLDOMAttributePtr domAttributeY = domDocument->createAttribute ("y");
			domAttributeY->Putvalue (pointAktuell.y);

			MSXML2::IXMLDOMNamedNodeMapPtr nnn = domElementPoint->attributes;
			nnn->setNamedItem ( domAttributeX);
			nnn->setNamedItem ( domAttributeY);

			domElementPoints->appendChild (domElementPoint);
		}

		//Das so erzeugte XML direkt als String ins Archive schreiben:
		ar.WriteString (domDocument->xml);
	}
	else
	{
		//Laden des XML-Strings aus dem Archive.
		//Bei Fehlern: CXMLException werfen. Diese ist von CFileException
		//abgeleitet. In CDocument werden die Meldungen aus CFileExceptions 
		//per MessageBox an den User gegeben und das Laden als "gescheitert" behandelt.

		MSXML2::IXMLDOMDocumentPtr domDocument; //pointer to the xml document
		::CoInitialize(NULL);

		HRESULT hr = domDocument.CreateInstance (CLSID_DOMDocument);
		if (FAILED (hr) )		//#define FAILED(Status) ((HRESULT)(STATUS) < 0)
		{
			//_com_error ist eine Kapselklasse um COM-Fehler.
			_com_error er (hr);
			//Saubere Exception mit Fehlermeldung auslsen:
			CString sError = "Fehler beim Initialisieren von MSXML: ";
			sError += er.ErrorMessage ();
			throw new CXMLException ( sError);
		}
		//Zuerst einmal den XML-String aus dem Archive holen.
		CString sXML;
		ar.ReadString (sXML);
		//Den XML-String parsen. Wenn Fehler, dann ist Rckgabe FALSe
		if (domDocument->loadXML( _bstr_t (sXML) ) == FALSE)
		{
			//Fehlerbehandlung: XML-Fehler mit ErrorCode und Reason ausgeben.
			//XML-Fehler werden von IXMLDOMParseError gekapselt.
			MSXML2::IXMLDOMParseErrorPtr parseError = domDocument->parseError;
			//Zuerst den ErrorCode holen (der wird nicht viel Info liefern)
			long lngErrorCode;
			parseError->get_errorCode (&lngErrorCode);
			//Jetzt den Reason (Fehlertext). Hilfsklasse "ComBSTR" bietet ein paar Hilfsmethoden,
			//u.a. fr CString-Konvertierung.
			CComBSTR bstrReason;
			parseError->get_reason (&bstrReason);
			//Und jetzt Ausgabe:
			CString strError;
			strError.Format ("Fehler beim Laden der XML-Datei ! Errorcode=%d, Reason: ", lngErrorCode);
			strError += bstrReason;
			throw new CXMLException (strError );
		}

		//Auswerten des Root-Elements "points":
		MSXML2::IXMLDOMElementPtr docElementPoints;
		docElementPoints = domDocument->documentElement;
		if (docElementPoints == NULL)
			throw new CXMLException ("Kein Wurzelelement vorhanden !");
		//Stimmt der Name eigentlich ?
		_bstr_t bstrTagName = docElementPoints->GettagName();
		if (bstrTagName != _bstr_t ("points") )
		{
			CString sError = "Kein Wurzelelement 'points' vorhanden, Wurzelelement ist '";
			sError.Append (bstrTagName);
			sError += "'";
			throw new CXMLException (sError);
		}

		//Dieses Element durchlaufen:
		MSXML2::IXMLDOMElementPtr docElementPoint = docElementPoints->firstChild;
		while (docElementPoint != NULL)
		{
			//Prfung auf gltigen Namen:
			bstrTagName = docElementPoint->GettagName();
			if (bstrTagName != _bstr_t ("point") )
			{
				CString sError = "Das Unterelement muss 'point' heien, gefunden wurde '";
				sError.Append (bstrTagName);
				sError += "'";
				throw new CXMLException (sError);
			}

			//Die Attribute dieses Points holen:
			MSXML2::IXMLDOMNamedNodeMapPtr namedNodeMap = docElementPoint->Getattributes ();
			//Suchen der Attribute "x" und "y":
			MSXML2::IXMLDOMAttributePtr docAttributeX = namedNodeMap->getNamedItem ("x");
			//Fehlercheck:
			if (docAttributeX == NULL)
				throw new CXMLException ("Kein Attribut 'x' gefunden !");
			MSXML2::IXMLDOMAttributePtr docAttributeY = namedNodeMap->getNamedItem ("y");
			if (docAttributeY == NULL)
				throw new CXMLException ("Kein Attribut 'y' gefunden !");

			//Den Wert der Attribute extrahieren und in Integer umwandeln:
			_bstr_t bstrValue = docAttributeX->value;
			int intX = atoi ( bstrValue);
			bstrValue = docAttributeY->value;
			int intY = atoi ( bstrValue);
			
			//Neuen Punkt zufgen:
			this->AddPoint ( intX, intY);

			//Nchsten Knoten holen (falls vorhanden):
			docElementPoint = docElementPoint->nextSibling;
		}
	}
}


// CXMLDoc Diagnose

#ifdef _DEBUG
void CXMLDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CXMLDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// CXMLDoc-Befehle

//Hinzufgen eines Punkts zur Liste.
void CXMLDoc::AddPoint(int int_X, int int_Y)
{
	this->listPoints->AddTail ( CPoint (int_X, int_Y) );
}

//Abrufen der Anzahl der angeklickten Punkte:
int CXMLDoc::GetPointNumber()
{
	return (int) this->listPoints->GetCount();
}

//Abrufen des Punkts "int_Index" innerhalb der Liste.
CPoint CXMLDoc::GetPointAt(int int_Index)
{
	//Prfen ob der Index gltig ist:
	//(Hier sollte im Idealfall eine Exception ausgelst werden).
	if (int_Index < 0 || int_Index >= this->GetPointNumber() )
		return CPoint (0, 0);

	CPoint point = (CPoint) this->listPoints->GetAt ( this->listPoints->FindIndex (int_Index) );
	return point;
}
